use std::fmt::Write;
use chrono::prelude::*;
use dim_sdk::{plugin_info, Context, DimPlugin, Result};

plugin_info!(
    Plug,                    // Your main global structs name that implements `DimPlugin`
    "clock",                 // Plugin name
    "1.0.0",                 // Plugin Version (leave empty for none)
    "GPLv3"                  // Plugin license (leave empty for none)
);

#[derive(Debug, Clone)]
struct Plug {
    ctx: Context
}


impl DimPlugin for Plug {
    fn init(ctx: Context) -> Result<Self> {
        Ok(Self {
            ctx
        })
    }
    fn on_message(&mut self, msg: dim_sdk::Message) -> Result<()> {
        self.ctx.buf.reset();
        match msg.name.as_str() {
            "poll" => {
                let local: DateTime<Local> = Local::now();
                let formatted_time = local.format("%H:%M (%Y-%m-%d)").to_string();
                write!(self.ctx, "Time: {}", formatted_time)?;
            }
            _ => ()
        }
        Ok(())
    }
    fn pre_reload(&mut self) -> Result<()> { Ok(()) }
    fn post_reload(&mut self) -> Result<()> { Ok(()) }
    fn free(&mut self) -> Result<()> { Ok(()) } 
}




