use std::fmt::Write;
use dim_sdk::{plugin_info, Context, DimPlugin, Message, Result};
use chrono::{NaiveDate, Local};

plugin_info!(
    Plug,                    // Your main global structs name that implements `DimPlugin`
    "counter",               // Plugin name
    "1.0.0",                 // Plugin Version (leave empty for none)
    "GPLv3"                  // Plugin license (leave empty for none)
    );

#[derive(Debug, Clone)]
struct Plug {
    ctx: Context
}

impl DimPlugin for Plug {
    fn init(ctx: Context) -> Result<Self> {
        Ok(Self {
            ctx
        })
    }
    fn on_message(&mut self, msg: Message) -> Result<()> {
        self.ctx.buf.reset();
        match msg.name.as_str() {
            "poll" => {
                let start_date = NaiveDate::from_ymd_opt(2024, 3, 8).expect("Invalid date");
                let current_date = Local::now().date_naive();
                let duration = current_date.signed_duration_since(start_date);

                write!(self.ctx, "{} days <3", duration.num_days())?;
            }
            _ => ()
        }
        Ok(())
    }
    fn pre_reload(&mut self) -> Result<()> { Ok(()) }
    fn post_reload(&mut self) -> Result<()> { Ok(()) }
    fn free(&mut self) -> Result<()> { Ok(()) }
}




