#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
// Only use this define once, cause it defines funcitons
#define PLUG_IMPL
#include "dim_sdk.h"

PLUG_INFO("example_c", "0.0.1", "GPLv3")

typedef struct plug_t {
    char* some_data;
    int count;
    plug_ctx_t ctx;
} plug_t;

plug_t* p = {0};

// If any function returns not 0 the plugin will be disabled
// Except for `pre_reload`, the plugin will be disabled if it is NULL
int plug_init(plug_ctx_t* ctx) {
    setup_ctx(ctx);
    p = malloc(sizeof(plug_t));
    assert(p != NULL && "Buy more ram KEKW");
    p->count = 0;
    p->ctx = *ctx;

    // log(INFO, "Hewo fwom C :3");
    return 0;
}

void* plug_pre_reload() {
    return p;
}

int plug_post_reload(void *state) {
    p = state;
    return 0;
}

int plug_on_msg(plug_msg_t* msg) {
    snprintf(p->ctx.buf, BUF_SZ, "Hello from C! (%d)", p->count++);
    return 0;
}

int plug_free() {
    free(p);
    return 0;
}
