use std::{io::Read, os::unix::net::UnixStream};

use crate::config::Config;

use super::Message;


pub struct IpcServer{
    sock: UnixStream
}

impl IpcServer {
    pub fn start(cfg: &Config) -> std::io::Result<Self> {
        Ok(Self {
            sock: UnixStream::connect(&cfg.sock_path)?,
        })
    }

    pub fn poll(&mut self) -> Option<Message> {
        let mut buf = String::new();
        let _ = self.sock.read_to_string(&mut buf);
        if buf.is_empty() {
            return None;
        }
        Some(Message::from_string(buf))
    }
}
